; This installer was designed to install the Lowkee33 Appalachian Terrain mod for SimCity 4
; It will not compile unless the files acutally exist, so download the mod to see what this script did
; I didn't see any Sim City 4 installers like it, so perhaps this will save someone time
; The installer has inclusive options
; Meaning, selecting to install option A installs file a
;          selecting to install option B installs file b
;          selecting to install option A AND B installs file c

; Note: The if statement could be trimmed down, but this way is pretty clear.

; Get access to If statements
!include "LogicLib.nsh"

; HM NIS Edit Wizard helper defines
!define PRODUCT_NAME "Appalachian Terrain Mod"
!define PRODUCT_VERSION "1.0"
!define PRODUCT_PUBLISHER "BSC - Lowkee33"
!define PRODUCT_WEB_SITE "http://www.sc4devotion.com"

; MUI 1.67 compatible ------
!include "MUI.nsh"

; MUI Settings
!define MUI_ABORTWARNING
!define MUI_ICON "${NSISDIR}\Contrib\Graphics\Icons\modern-install.ico"

; Finish page turned into a Welcome page - To have a "Show Readme" option first.
!define MUI_WELCOMEFINISHPAGE_BITMAP "BSCInstallerLogo-LeftLK33.bmp"
!define MUI_FINISHPAGE_TITLE "Welcome to the Lowkee33 Appalachian Terrain Installer"
!define MUI_FINISHPAGE_TEXT_LARGE
!define MUI_FINISHPAGE_TEXT "The readme contains information about your options, so it is useful before installing.\n\nAfter installing, it can be found in:\n\nMy Docs\\SimCity 4\\LEX_Downloads\\BSC\\Lowkee33\\Terrain."
!define MUI_FINISHPAGE_SHOWREADME "LK33_AppalachianTerrain_Readme.html"
!define MUI_FINISHPAGE_BUTTON "Proceed"
!insertmacro MUI_PAGE_FINISH

; License page
!insertmacro MUI_PAGE_LICENSE "C:\Documents and Settings\User\Desktop\InstallTest\Licence.txt"
; Components page
!insertmacro MUI_PAGE_COMPONENTS
; Directory page
!insertmacro MUI_PAGE_DIRECTORY
; Instfiles page
!insertmacro MUI_PAGE_INSTFILES
; Finish page
!define MUI_FINISHPAGE_SHOWREADME "$DOCUMENTS\SimCity 4\LEX_Downloads\BSC\Lowkee33\Terrain\LK33_AppalachianTerrain_Readme.html"
!insertmacro MUI_PAGE_FINISH

; Language files
!insertmacro MUI_LANGUAGE "English"

; MUI end ------

Name "${PRODUCT_NAME} ${PRODUCT_VERSION}"
OutFile "Install_LK33_Appalachian_Terrain_Mod.exe"
InstallDir "$DOCUMENTS\SimCity 4\plugins\zzz_terrain"
ShowInstDetails show

; First make the radio buttons, you can find the descrptions at the end

Section "Documentation" SEC01
  sectionin RO ; RO defines this as mandatory
  SetOutPath "$DOCUMENTS\SimCity 4\LEX_Downloads\BSC\Lowkee33\Terrain\Images"
  File "C:\Documents and Settings\User\Desktop\InstallTest\images\"
  SetOutPath "$DOCUMENTS\SimCity 4\LEX_Downloads\BSC\Lowkee33\Terrain"
  SetOverwrite ifnewer
  File "C:\Documents and Settings\User\Desktop\InstallTest\LK33_AppalachianTerrain_Readme.html"

SectionEnd

Section /o "Snow" SEC02 ; /o declares this button as not pressed by default
SectionEnd
Section /o "Higher Terrain" SEC03
SectionEnd
Section /o "Jagged Edge Mod" SEC04
SectionEnd
Section /o "Coastal Mod" SEC05
SectionEnd
Section /o "Magic Carpet Mod" SEC06
SectionEnd
Section /o "No Erosion" SEC07
SectionEnd

; This is where choices are separated
Section -Post

; The installer waits until the user hits "next"
; For each check box checked, the next binary number is added to $0
; Every combination of check boxes produces a unique value of $0
; Remember, SEC01 is the readme.

${if} ${SectionIsSelected} ${SEC02};
      System::Int64Op 0 + 1
      pop $0
      System::Int64Op 0 + 1
      pop $1
${endif}

${if} ${SectionIsSelected} ${SEC03};
      System::Int64Op $0 + 2
      pop $0
${endif}

${if} ${SectionIsSelected} ${SEC04};
      System::Int64Op $0 + 4
      pop $0
${endif}

${if} ${SectionIsSelected} ${SEC05};
      System::Int64Op $0 + 8
      pop $0
${endif}

${if} ${SectionIsSelected} ${SEC06};
      System::Int64Op $0 + 16
      pop $0
${endif}

${if} ${SectionIsSelected} ${SEC07};
      System::Int64Op $0 + 32
      pop $0
${endif}

; Remove the existing mod files

delete "$INSTDIR\LK_AppalachianTerrain.dat"
delete "$INSTDIR\LK_AppalachianTerrain_Snow.dat"
delete "$INSTDIR\LK_AppalachianTerrain_High.dat"
delete "$INSTDIR\LK_AppalachianTerrain_Snow_High.dat"
delete "$INSTDIR\LK_AppalachianTerrain_Jagged.dat"
delete "$INSTDIR\LK_AppalachianTerrain_Snow_Jagged.dat"
delete "$INSTDIR\LK_AppalachianTerrain_High_Jagged.dat"
delete "$INSTDIR\LK_AppalachianTerrain_Snow_High_Jagged.dat"
delete "$INSTDIR\LK_AppalachianTerrain_Coast.dat"
delete "$INSTDIR\LK_AppalachianTerrain_Snow_Coast.dat"
delete "$INSTDIR\LK_AppalachianTerrain_High_Coast.dat"
delete "$INSTDIR\LK_AppalachianTerrain_Snow_High_Coast.dat"
delete "$INSTDIR\LK_AppalachianTerrain_Jagged_Coast.dat"
delete "$INSTDIR\LK_AppalachianTerrain_Snow_Jagged_Coast.dat"
delete "$INSTDIR\LK_AppalachianTerrain_High_Jagged_Coast.dat"
delete "$INSTDIR\LK_AppalachianTerrain_Snow_High_Jagged_Coast.dat"
delete "$INSTDIR\LK_AppalachianTerrain_Magic.dat"
delete "$INSTDIR\LK_AppalachianTerrain_Snow_Magic.dat"
delete "$INSTDIR\LK_AppalachianTerrain_High_Magic.dat"
delete "$INSTDIR\LK_AppalachianTerrain_Snow_High_Magic.dat"
delete "$INSTDIR\LK_AppalachianTerrain_Jagged_Magic.dat"
delete "$INSTDIR\LK_AppalachianTerrain_Snow_Jagged_Magic.dat"
delete "$INSTDIR\LK_AppalachianTerrain_High_Jagged_Magic.dat"
delete "$INSTDIR\LK_AppalachianTerrain_Snow_High_Jagged_Magic.dat"
delete "$INSTDIR\LK_AppalachianTerrain_Coast_Magic.dat"
delete "$INSTDIR\LK_AppalachianTerrain_Snow_Coast_Magic.dat"
delete "$INSTDIR\LK_AppalachianTerrain_High_Coas_Magict.dat"
delete "$INSTDIR\LK_AppalachianTerrain_Snow_High_Coast_Magic.dat"
delete "$INSTDIR\LK_AppalachianTerrain_Jagged_Coast_Magic.dat"
delete "$INSTDIR\LK_AppalachianTerrain_Snow_Jagged_Coast_Magic.dat"
delete "$INSTDIR\LK_AppalachianTerrain_High_Jagged_Coast_Magic.dat"
delete "$INSTDIR\LK_AppalachianTerrain_Snow_High_Jagged_Coast_Magic.dat"

delete "$INSTDIR\zLK_AppalachianTerrain_INI_NoErosion.dat"
delete "$INSTDIR\zLK_AppalachianTerrain_INI_Snow_NoErosion.dat"


;Set the out path to the plugin folder and not the readme folder

SetOutPath "$INSTDIR"

File "C:\Documents and Settings\User\Desktop\InstallTest\LK_WeatherTuning_Stagnant.dat"

;  Then to install files dependent upon $0
;  The no-erosion mod installs in addition to the other file.
;  It will make $0 >= 32, so we check for that, and for the snow flag from SEC02

${if} $0 >= 32
  ${if} $1 = 0
   File "C:\Documents and Settings\User\Desktop\InstallTest\zLK_AppalachianTerrain_INI_NoErosion.dat"
  ${endif}
  ${if} $1 = 1
   File "C:\Documents and Settings\User\Desktop\InstallTest\zLK_AppalachianTerrain_INI_Snow_NoErosion.dat"
  ${endif}
  System::Int64Op $0 - 32   ;Make $0 whatever it would be had the no erosion mod not been picked
  pop $0
${endif}

;  Then the actual file.


${if} $0 = 0
File "C:\Documents and Settings\User\Desktop\InstallTest\LK_AppalachianTerrain.dat"
${endif}
${if} $0 = 1
File "C:\Documents and Settings\User\Desktop\InstallTest\LK_AppalachianTerrain_Snow.dat"
${endif}

${if} $0 = 2
File "C:\Documents and Settings\User\Desktop\InstallTest\LK_AppalachianTerrain_High.dat"
${endif}
${if} $0 = 3
File "C:\Documents and Settings\User\Desktop\InstallTest\LK_AppalachianTerrain_Snow_High.dat"
${endif}

${if} $0 = 4
File "C:\Documents and Settings\User\Desktop\InstallTest\LK_AppalachianTerrain_Jagged.dat"
${endif}
${if} $0 = 5
File "C:\Documents and Settings\User\Desktop\InstallTest\LK_AppalachianTerrain_Snow_Jagged.dat"
${endif}
${if} $0 = 6
File "C:\Documents and Settings\User\Desktop\InstallTest\LK_AppalachianTerrain_High_Jagged.dat"
${endif}
${if} $0 = 7
File "C:\Documents and Settings\User\Desktop\InstallTest\LK_AppalachianTerrain_Snow_High_Jagged.dat"
${endif}

${if} $0 = 8
File "C:\Documents and Settings\User\Desktop\InstallTest\LK_AppalachianTerrain_Coast.dat"
${endif}
${if} $0 = 9
File "C:\Documents and Settings\User\Desktop\InstallTest\LK_AppalachianTerrain_Snow_Coast.dat"
${endif}
${if} $0 = 10
File "C:\Documents and Settings\User\Desktop\InstallTest\LK_AppalachianTerrain_High_Coast.dat"
${endif}
${if} $0 = 11
File "C:\Documents and Settings\User\Desktop\InstallTest\LK_AppalachianTerrain_Snow_High_Coast.dat"
${endif}
${if} $0 = 12
File "C:\Documents and Settings\User\Desktop\InstallTest\LK_AppalachianTerrain_Jagged_Coast.dat"
${endif}
${if} $0 = 13
File "C:\Documents and Settings\User\Desktop\InstallTest\LK_AppalachianTerrain_Snow_Jagged_Coast.dat"
${endif}
${if} $0 = 14
File "C:\Documents and Settings\User\Desktop\InstallTest\LK_AppalachianTerrain_High_Jagged_Coast.dat"
${endif}
${if} $0 = 15
File "C:\Documents and Settings\User\Desktop\InstallTest\LK_AppalachianTerrain_Snow_High_Jagged_Coast.dat"
${endif}


${if} $0 = 16
File "C:\Documents and Settings\User\Desktop\InstallTest\LK_AppalachianTerrain_Magic.dat"
${endif}
${if} $0 = 17
File "C:\Documents and Settings\User\Desktop\InstallTest\LK_AppalachianTerrain_Snow_Magic.dat"
${endif}
${if} $0 = 18
File "C:\Documents and Settings\User\Desktop\InstallTest\LK_AppalachianTerrain_High_Magic.dat"
${endif}
${if} $0 = 19
File "C:\Documents and Settings\User\Desktop\InstallTest\LK_AppalachianTerrain_Snow_High_Magic.dat"
${endif}
${if} $0 = 20
File "C:\Documents and Settings\User\Desktop\InstallTest\LK_AppalachianTerrain_Jagged_Magic.dat"
${endif}
${if} $0 = 21
File "C:\Documents and Settings\User\Desktop\InstallTest\LK_AppalachianTerrain_Snow_Jagged_Magic.dat"
${endif}
${if} $0 = 22
File "C:\Documents and Settings\User\Desktop\InstallTest\LK_AppalachianTerrain_High_Jagged_Magic.dat"
${endif}
${if} $0 = 23
File "C:\Documents and Settings\User\Desktop\InstallTest\LK_AppalachianTerrain_Snow_High_Jagged_Magic.dat"
${endif}
${if} $0 = 24
File "C:\Documents and Settings\User\Desktop\InstallTest\LK_AppalachianTerrain_Coast_Magic.dat"
${endif}
${if} $0 = 25
File "C:\Documents and Settings\User\Desktop\InstallTest\LK_AppalachianTerrain_Snow_Coast_Magic.dat"
${endif}
${if} $0 = 26
File "C:\Documents and Settings\User\Desktop\InstallTest\LK_AppalachianTerrain_High_Coast_Magic.dat"
${endif}
${if} $0 = 27
File "C:\Documents and Settings\User\Desktop\InstallTest\LK_AppalachianTerrain_Snow_High_Coast_Magic.dat"
${endif}
${if} $0 = 28
File "C:\Documents and Settings\User\Desktop\InstallTest\LK_AppalachianTerrain_Jagged_Coast_Magic.dat"
${endif}
${if} $0 = 29
File "C:\Documents and Settings\User\Desktop\InstallTest\LK_AppalachianTerrain_Snow_Jagged_Coast_Magic.dat"
${endif}
${if} $0 = 30
File "C:\Documents and Settings\User\Desktop\InstallTest\LK_AppalachianTerrain_High_Jagged_Coast_Magic.dat"
${endif}
${if} $0 = 31
File "C:\Documents and Settings\User\Desktop\InstallTest\LK_AppalachianTerrain_Snow_High_Jagged_Coast_Magic.dat"
${endif}

sectionend

; Section descriptions
!insertmacro MUI_FUNCTION_DESCRIPTION_BEGIN
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC01} "Documentation"
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC02} "Choose to have snow or not"
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC03} "Tunes the mod for higher terrains"
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC04} "Ennedi's Jagged Edge Mod"
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC05} "Makes the water more transparent"
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC06} "DobDriver's Magic Carpet Mod (part of his HD sky background)"
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC07} "For more accurate region rendering (can be removed afterwards)"
!insertmacro MUI_FUNCTION_DESCRIPTION_END



